// akter.h – Apstraktna klasa
//           aktera.

#ifndef _akter_h_
#define _akter_h_

#include <cstdlib>
#include <iostream>
using std::rand, std::ostream;

class Akter {
  static inline int pos_id{0};     // Poslednji identifikator.
  int id{++pos_id};                // Identifikator aktera.
  double t_min, t_max;             // Min i max vreme između dve radnje.
  double t;                        // Preostalo vreme do sledeće radnje.
  void kopiraj(const Akter& a)     // Kopiranje u objekat (bez ident.!).
    { t_min = a.t_min; t_max = a.t_max; t = a.t; }
  double t_sluc()                  // Generisanje slučajnog vremena.
    { return t_min + (t_max-t_min)*rand()/(RAND_MAX+1); }
  virtual void radnja() =0;        // Radnja aktera.
 
public:
  Akter(double t_min=0, double t_max=1)           // Inicijalizacija.
    : t_min{t_min}, t_max{t_max}, t{0} {}
  Akter(const Akter& a) { kopiraj(a); }           // Kopirajući konstruktor.
  virtual ~Akter() {}                             // Virtuelan destruktor.
  Akter& operator=(const Akter& a) {              // Dodela vrednosti.
    kopiraj(a);
    return *this;
  }
  void proteklo(double dt) {       // Saopštavanje proteklog vremena.
    if ((t -= dt) <= 0) { radnja(); t = t_sluc(); }
  }
  friend ostream& operator<<(ostream& it, const Akter& a) // Pisanje.
    { return it << "    " << a.id; }
};

#endif
