// boja.h - Klasa boja.

#ifndef _boja_h_
#define _boja_h_

#include <iostream>
using std::ostream;

namespace Figure {
  class G_boja {};                        // KLASA GREŠAKA: Neispravna boja.
  inline ostream& operator<<(ostream& it, const G_boja&)
    { return it << "*** Neispravna boja! ***"; }

  class Boja {                            // KLASA BOJA:
    double c, z, p;
  public:
    Boja(): c{1}, z{1}, p{1} {}           // Konstruktori.
    Boja(double c, double z, double p)
      : c{c}, z{z}, p{p} {
      if (c<0 || c>1 || z<0 || z>1 || p<0 || p>1)
        throw G_boja();
    }
    friend ostream& operator<<(ostream& it, const Boja& b) // Pisanje.
      { return it << '(' << b.c << ',' << b.z << ',' << b.p << ')'; }
  }; // class Boja
} // namespace Figure

#endif
