// casovnik.h - Klasa časovnika.

#ifndef _casovnik_h_
#define _casovnik_h_

#include "akter.h"

class Casovnik {
  struct Elem {                              // Element liste aktera.
    Akter* akter; Elem* sled;
    Elem(Akter* akt): akter{akt}, sled{nullptr} {}
  };
  Elem *prvi, *posl;                         // Prvi i poslednji element.
public:
  Casovnik(): prvi{nullptr}, posl{nullptr} {}// Stvaranje praznog časovnika.
  Casovnik(const Casovnik&) =delete;         // Ne sme da se kopira.
  void operator=(const Casovnik&) =delete;   // Ne sme da se dodeljuje.
  ~Casovnik();                               // Destruktor.
  Casovnik& operator+=(Akter* akt) {         // Prijavljivanje aktera.
    posl = (!prvi ? prvi : posl->sled) = new Elem(akt);
    return *this;
  }
  Casovnik& operator-=(Akter* akt);          // Odjavljivanje aktera.
  void radi(double dt, double maxT);         // Rad časovnika.
};

#endif
