// djak.h - Klasa đaka.

#ifndef _djak_h_
#define _djak_h_

#include "osoba4.h"
#include "lista7.h"
#include "ispit.h"
#include <string>
#include <iostream>
using std::string, std::ostream;

class Djak: public Osoba {
  Lista<Ispit*> ispiti;                    // Lista ispita.
  void pisi(ostream& it) const override    // Pisanje đaka.
    { Osoba::pisi(it); it << ": " << srOce(); }
public:
  Djak(string ime, const Datum& rodj)      // Konstruktor.
    : Osoba{ime, rodj} {}
  ~Djak();                                 // Destruktor.
  Djak& operator+=(Ispit* isp)             // Dodavanje ispita.
    { ispiti.dodaj(isp); return *this; }
  double srOce() const;                    // Srednja ocena.
};

#endif
