// duz1.h - Klasa duži u ravni.

#ifndef _duz1_h_
#define _duz1_h_

#include "linija.h"
#include "tacka6.h"
#include <cmath>
#include <utility>
using std::sqrt, std::pow, std::move;

namespace Linije {
  class Duz: public Linija {
    Tacka A, B;                                 // Krajnje tačke.
  public:
    explicit Duz(const Tacka& A=Tacka(-1,-1),   // Konstruktor.
                 const Tacka& B=Tacka(1,1)): A{A}, B{B} {}
    double duzina() const override                   // Dužina duži.
      { return sqrt(pow(A.aps()-B.aps(),2) + pow(A.ord()-B.ord(),2)); }
    Duz* kopija() const& override               // Kopija duži kopiranjem.
      { return new Duz(*this); }
    Duz* kopija() && override                   // Kopija duži premeštanjem.
      { return new Duz(move(*this)); }
  private:
    void pisi(ostream& it) const override       // Pisanje duži.
      { Linija::pisi(it); it << "[duz: A" << A << ", B" << B << ']'; }
  };
}

#endif
