// integ.cpp – Definicija
//   funkcije za računanje 
//   određenog integrala.

#include "integ.h"

double Funkcije::integ(const Fun& f, double a, double b) {
  const int BR_INTERVALA = 30;
  try {                                        // Pokušaj tačnog računanja.
    return f.I(b) - f.I(a);
  } catch (G_nema_int) {                       // Približno računanje.
    double dx = (b - a) / BR_INTERVALA, s = 0;
    for (int i=0; i<BR_INTERVALA; i++) s += f(a+i*dx);
    return s * dx;
  }
}
