// kvadar1.h - Definicija klase kvadara.

#include <iostream>
using std::cin, std::cout;

class Kvadar {
  static inline double Vmax = 0;          // Dozvoljena ukupna zapremina.
  static inline double Vuk  = 0;          // Trenutna ukupna zapremina.
  double a, b, c;                         // Dužine ivica kvadra.

  Kvadar(double aa, double bb, double cc) // Konstruktor samo za interne
    : a(aa), b(bb), c(cc) {}              //   potrebe.

public:
  Kvadar(const Kvadar&) = delete;         // Ne sme da se kopira.

  static bool postavi_Vmax(double maxV) { // Postavljanje maksimalne
    if (maxV < Vuk) return false;         //   zapremine.
    Vmax = maxV;
    return true;
  }

  static double dohv_Vmax()               // Dohvatanje maksimalne
    { return Vmax; }                      //   zapremine.

  static double dohv_Vuk()                // Dohvatanje trenutne
    { return Vuk; }                       //   ukupne zapremine.

  static Kvadar* pravi(double a, double b, double c) { // Stvaranje
    double V = a * b * c;                 //   dinamičkog kvadra.
    if (a<=0 || b<=0 || c<= 0 || Vuk+V>Vmax) return nullptr;
    Vuk += V; return new Kvadar(a, b, c);
  }

  static Kvadar* citaj() {                // Čitanje kvadra.
    double a, b, c; cin >> a >> b >> c;
    return pravi(a, b, c);
  }

  ~Kvadar() { Vuk -= a * b * c; }         // Uništavanje kvadra.

  double dohv_a() const { return a; }     // Dohvatanje dužina ivica.
  double dohv_b() const { return b; }
  double dohv_c() const { return c; }

  double V() const { return a * b * c; }  // Zapremina kvadra.

  void pisi() const                       // Pisanje kvadra.
    { cout << "kvadar[" << a << ',' << b << ',' << c << ']'; }
};
