// lista3.h - Definicija klase listi
//            celih brojeva (rekurzivno).

#include <iostream>
using std::cin, std::cout;

class Lista {
  struct Elem {                  // Element liste:
    int broj;                    // - sadržaj,
    Elem* sled;                  // - pokazivač na sledeći,
    Elem(int b, Elem* s=nullptr) // - konstruktor.
      : broj(b), sled(s) {}
  };
  Elem* prvi;                    // Pokazivač na početak liste.
public:                          // Konstruktori:
  Lista(): prvi(nullptr) {}      // - podrazumevani,
  Lista(int b)                   // - konvertujući,
    : prvi(new Elem(b)) {}
  Lista(const Lista& lst)        // - kopirajući,
    { prvi = nullptr; kopiraj(lst.prvi); }
  Lista(Lista&& lst)             // - premeštajući.
    { prvi = lst.prvi; lst.prvi = nullptr; }
  ~Lista() { brisi(prvi); }      // Destruktor.
  int duz() const                // Broj elemenata liste.
    { return duz(prvi); }
  void pisi() const              // Ispisivanje liste.
    { pisi(prvi); }
  void na_pocetak(int b)         // Dodavanje na početak.
    { prvi = new Elem(b, prvi); }
  void na_kraj(int b)            // Dodavanje na kraj.
    { naKraj(prvi, b); }
  void citaj1(int n)  // Čitanje liste stavljajući brojeve na početak.
    { prazni(); citaj1(prvi, n); }
  void citaj2(int n)  // Čitanje liste stavljajući brojeve na kraj.
    { prazni(); citaj2(prvi, n); }
  void umetni(int b)             // Umetanje u uređenu listu.
    { umetni(prvi, b); }
  void prazni()                  // Pražnjenje liste.
    { brisi(prvi); }
  void izostavi(int b)           // Izostavljanje svakog pojavljivanja.
    { izostavi(prvi, b); }
private:                                    // POMOĆNE REKURZIVNE METODE:
  static Elem* kopiraj(Elem* lst) {         // Kopiranje liste.
    return lst ? new Elem(lst->broj, kopiraj(lst->sled)) : nullptr;
  }
  static int duz(Elem* lst)      // Broj elemenata liste.
    { return lst ? 1+duz(lst->sled) : 0; }
  static void pisi(Elem* lst) {  // Ispisivanje liste.
    if (lst) 
      { cout << lst->broj << ' '; pisi(lst->sled); }
  }
  static void naKraj(Elem*& lst, int b) {   // Dodavanje na kraj.
    if (!lst) lst = new Elem(b);
      else naKraj(lst->sled, b);
  }
  static void citaj1(Elem*& lst, int n) {   // Čitanje stavljajući na
    if (n) {                                //   početak.
      lst = new Elem(0);
      citaj1(lst->sled, n-1);
      cin >> lst->broj; 
    }
  }
  static void citaj2(Elem*& lst, int n) {   // Čitanje stavljajući na kraj.
    if (n) {
      int b; cin >> b; lst = new Elem(b);
      citaj2(lst->sled, n-1);
    }
  }
  static void umetni(Elem*& lst, int b) {   // Umetanje u uređenu listu.
    if (!lst || lst->broj>=b)
      lst = new Elem(b, lst);
    else
      umetni(lst->sled, b);
  }
  static void brisi(Elem*& lst) {           // Oslobađanje memorije.
    if (lst) { brisi(lst->sled);
               delete lst; lst = nullptr; }
  }
  static void izostavi(Elem*& lst, int b) { // Izostavljanje svakog
    if (lst) {                              //   pojavljivanja.
      izostavi(lst->sled, b);
      if (lst->broj == b) {
        Elem* stari = lst; 
        lst = lst->sled; delete stari;
      }
    }
  }
};
