// lista_dat.cpp - Definicije metoda klase listi datuma.

#include "lista_dat.h"
#include <iostream>

Lista::Lista(const Lista& lst) {         // Kopirajući konstruktor.
  prvi = posl = nullptr; duz = 0;
  for (Elem* tek=lst.prvi; tek; tek=tek->sled) dodaj(tek->dat);
}

Lista::~Lista() {                        // Destruktor.
  while (prvi) { Elem* stari = prvi; prvi = prvi->sled; delete stari; }
}

const Datum* Lista::max() const {        // Najkasniji (svežiji) datum.
  if (!prvi) return nullptr;
  Datum* m = &prvi->dat;
  for (Elem* tek=prvi->sled; tek; tek=tek->sled)
    if (m->uporedi(tek->dat) < 0) m = &tek->dat;
  return m;
}

void Lista::pisi() const {        // Pisanje liste.
  for (Elem* tek=prvi; tek; tek=tek->sled)
    { tek->dat.pisi(); std::cout << ' '; }
}
