// mnogougao2.h - Klasa obojenih mnogouglova.

#ifndef _mnogougao2_h_
#define _mnogougao2_h_

#include "figura3.h"
#include "niz4.h"
#include <utility>
using std::move;

namespace Figure {
  class Mnogougao: public Figura {
    Niz<Tacka> temena; // Temena mnogougla.
  public:              // Konstruktor.
    explicit Mnogougao(const Niz<Tacka>& tem, Boja b=Boja{})
      : Figura{b}, temena{tem} {}
    Mnogougao* kopija() const& override // Kopija mnogougla kopiranjem.
      { return new Mnogougao(*this); }
    Mnogougao* kopija() && override     // Kopija mnogougla premeštanjem.
      { return new Mnogougao(move(*this)); }
    bool pripada(const Tacka& T) const override; // Da li tačka pripada?
  }; // class Mnogougao
 
  inline bool Figure::Mnogougao::pripada(const Tacka& T) const { // Da li
    for (int i=1; i<temena.vel()-1; i++)                         // pripada?
      if (Trougao(temena[0],temena[i],temena[i+1]).pripada(T))
        return true;
    return false;
  }
} // namespace Figure

#endif
