// naredba.h - Apstraktna klasa naredbi.

#ifndef _naredba_h_
#define _naredba_h_

#include <iostream>
#include <iomanip>
using std::ostream, std::setw;

namespace Naredbe {
  class Naredba {
  public:
    virtual ~Naredba() =default;          // Virtuelan destruktor.
    virtual void izvrsi() const =0;       // Izvršavanje naredbe.
    virtual Naredba* kopija() const =0;   // Kopija naredbe.
  protected:
    static inline int nivo{0};            // Nivo naredbe pri pisanju.
    virtual void pisi(ostream& it) const  // Pisanje.
      { it << setw(nivo*2) << ""; }
    friend ostream& operator<<(ostream& it, const Naredba& nar)
      { nar.pisi(it); return it; }
  }; // class Naredba
} // namespace Naredbe

#endif
