// niz_mat_tac.h - Definicija klase nizova materijalnih tačaka.

#include "mat_tacka.h"

class Niz_mat_tac {
  Mat_tacka* niz;                              // Niz tačaka.
  int kap, duz;                                // Kapacitet i dužina niza.
public:
  explicit Niz_mat_tac(int kap=5)              // Stvaranje praznog niza.
    : niz(new Mat_tacka[kap]), kap(kap), duz(0) {}
  Niz_mat_tac(const Niz_mat_tac& nmt);         // Kopirajući konstruktor.
  Niz_mat_tac(Niz_mat_tac&& nmt) {             // Premeštajući konstruktor.
    niz = nmt.niz; nmt.niz = nullptr;
    kap = nmt.kap; duz = nmt.duz;
  }
  ~Niz_mat_tac() { delete [] niz; }            // Destruktor.
  int vel() const { return duz; }              // Veličina niza.
  Niz_mat_tac& dodaj(const Mat_tacka& mt);     // Dodavanje tačke.
  Mat_tacka max_F(const Mat_tacka& mt) const;  // Najjača tačka.
  void pisi() const;                           // Pisanje niza.
};
