// p_vagon.h - Klasa putničkih vagona.

#ifndef _p_vagon_h_
#define _p_vagon_h_

#include "vozilo2.h"
#include <utility>
using std::move;

namespace Vozovi {
  class G_previse_putnika {};      // KLASA GREŠAKA: Previše putnika.
  inline ostream& operator<<(ostream& it, const G_previse_putnika&)
    { return it << "*** Previse putnika! ***"; }

  class P_vagon: public Vozilo {   // KLASA PUTNIČKIH VAGONA:
    static inline float sr_tez_put{70};     // Srednja težina putnika.
    int kap, br_put;                 // Kapac. vagona i trenutni broj putn.
    void pisi(ostream& it) const override { // Pisanje vagona.
      Vozilo::pisi(it); it << '(' << br_put << ','
                           << br_put*sr_tez_put << ')';
    }
  public:
    static const char VR = 'P';              // Oznaka za putničke vagone.
    static void post_sr_tez_put(float stp)   // Postavljanje sr. tež. putn.
      { sr_tez_put = stp; }
    static float dohv_sr_tez_put()           // Dohvatanje sr. tež. putn.
      { return sr_tez_put; }
    P_vagon(float sop_tez, int kap=50)       // Konstruktor.
       : Vozilo(sop_tez), kap{kap}, br_put{0} {}
    char vrsta() const override { return VR; }          // Oznaka vrste.
    float uk_tezina() const override                    // Ukupna težina.
      { return sop_tezina() + br_put*sr_tez_put; }
    P_vagon* kopija() const& override        // Kopija vagona kopiranjem.
      { return new P_vagon(*this); }
    P_vagon* kopija() && override            // Kopija vagona premeštanjem.
      { return new P_vagon(move(*this)); }
    P_vagon& ulazePutnici(int broj) {        // Ulazak putnika.
      if (br_put+broj > kap) throw G_previse_putnika();
      br_put += broj; return *this;
    }
    P_vagon& izlazePutnici(int broj) {       // Izlazak putnika.
      br_put = (broj <= br_put) ? br_put-broj : 0;
      return *this;
    }
  }; // class p_vagon
} // namespace Vozovi

#endif
