// polica.h - Klasa polica za knjige.

#ifndef _polica_h_
#define _polica_h_

#include "knjiga.h"
#include <iostream>
using std::ostream, std::endl;

class Polica {
  const Knjiga** knjige;                         // Niz knjiga.
  int br_mesta;                                  // Broj mesta na polici.
  int br_knjiga;                                 // Trenutni broj knjiga.
public:
  Polica(int br_mesta = 10);                     // Inicijalizacija.
  Polica(const Polica&) =delete;                 // Ne može da se kopira.
  void operator=(const Polica&) =delete;         // Ne može da se dodlejuje.
  ~Polica() { delete [] knjige; }                // Uništavanje.
  bool operator+=(const Knjiga* k);              // Stavljanje knjige.
  const Knjiga* operator-=(int poz);             // Uzimanje knjige.
  double uk_vrednost() const;                    // Ukupna vrednost knjiga.
  friend ostream& operator<<(ostream& it, const Polica& p); // Pisanje.
};

#endif
