// potrosac2.h - Generička klasa potrošača.

#ifndef _potrosac2_h_
#define _potrosac2_h_

#include "akter.h"
#include "skladiste.h"
using std::cout, std::endl;

template <typename T>
class Potrosac: public Akter {
  Skladiste<T>* sklad;                           // Izvorišno skladište.
public:
  Potrosac(Skladiste<T>* sklad,                  // Inicijalizacija.
           double t_min=0, double t_max=1)
    : Akter{t_min, t_max},  sklad{sklad} {}
  void radnja() override {                       // Radnja potrošača.
    cout << *this << ": ";
    try { cout << "uzeo " << sklad->uzmi() << endl; }
      catch (G_prazno g) { cout << g << endl; }
  }
};

#endif
