// pravoug3.h - Klasa obojenih pravougaonika u ravni.

#ifndef _pravoug3_h_
#define _pravoug3_h_

#include "figura3.h"
#include <utility>
using std::move;

namespace Figure {
  class Pravoug: public Figura {
  protected:
    Tacka A;                           // Donje levo teme.
    double sir, vis;                   // Širina i visina.
  public:                              // Konstruktor.
    explicit Pravoug(Tacka A=Tacka(), double s=1, double v=1, Boja b=Boja{})
      : Figura{b}, A{A}, sir{s}, vis{v} {}
    Pravoug* kopija() const& override  // Kopija pravougaonika kopiranjem.
      { return new Pravoug(*this); }
    Pravoug* kopija() && override      // Kopija pravougaonika premeštanjem.
      { return new Pravoug(move(*this)); }
    bool pripada(const Tacka& T) const override { // Da li tačka pripada?
      return A.x()<=T.x() && T.x()<=A.x()+sir &&
             A.y()<=T.y() && T.y()<=A.y()+vis;
    }
  }; // class Pravoug
} // namespace Figure

#endif
