// predstava.h - Klasa predstava.

#include "karta.h"
#include <iostream>
#include <string>
using std::string, std::ostream, std::endl;

class Predstava {
  string naslov;                       // Naslov.
  long datum;                          // Datum održavanja.
  Karta*** karte;                      // Matrica karata.
  int br_red, duz_red;                 // Broj redova i dužina redova.
  void kopiraj(const Predstava& p);    // Kopiranje u objekat.
  void premesti(Predstava& p) {        // Premeštanje u objekat.
    naslov = p.naslov; datum = p.datum;
    karte = p.karte; br_red = p.br_red; duz_red = p.duz_red;
    p.karte = nullptr;
  }
  void brisi();                        // Oslobađanje memorije.
public:                                             // Konstruktori:
  Predstava(string nas, long dat,                   // - novog objekta,
            int br_r, int duz_r);
  Predstava(const Predstava& p) { kopiraj(p); }     // - kopirajući,
  Predstava(Predstava&& p) { premesti(p); }         // - premeštajući.
  ~Predstava() { brisi(); }                         // Destruktor.
  Predstava& operator=(const Predstava& p) {        // Dodela vrednosti:
    if (this != &p) { brisi(); kopiraj(p); }        // - kopirajuća,
    return *this;
  }
  Predstava& operator=(Predstava&& p) {             // - premeštajuća.
    if (this != &p) { brisi(); premesti(p); }
    return *this;
  }                                                 // Dohvatanje:
  string dohv_naslov() const { return naslov; }     // - naslova,
  long dohv_datum() const { return datum; }         // - datuma,
  int dohv_br_red() const { return br_red; }        // - broja redova,
  int dohv_duz_red() const { return duz_red; }      // - dužine redova.
  bool operator+=(const Karta& k);                  // Dodavanje karte.
  float vrednost() const;                           // Vrednost svih karata.
  friend ostream& operator<<(ostream& it, const Predstava& p); // Pisanje.
};
