// radnik1.h - Klasa radnika.

#ifndef _radnik1_h_
#define _radnik1_h_

#include "proizvod1.h"
#include "masina.h"
#include <iostream>
#include <string>
using std::string, std::ostream;

namespace Fabrika {
  class G_nema_masinu { // KLASA GREŠAKA: Radnik nema mašinu.
    string ime; int id; // Ime i identifikator problematičnog radnika.
  public:
    G_nema_masinu(string ime, int id)             // Inicijalizacija.
      : ime{ime}, id{id} {}
    void operator=(const G_nema_masinu&) =delete; // Ne sme da se dodeljuje.
    friend ostream& operator<<(ostream& it, const G_nema_masinu& g) {
      return it << "\n*** Radniku " << g.ime << ", id " << g.id
                << ", nije dodeljena masina ***\n\a";
    }
  }; // class G_nema_masinu

  class Radnik {         // KLASA RADNIKA:
    static inline int pos_id{0}; // Poslednji identifikator.
    const int id{++pos_id};      // Identifikator radnika.
    string ime;          // Ime radnika.
    Masina* mas;         // Mašina koju radnik koristi (nije joj vlasnik).
    int br;              // Broj napravljenih proizvoda na masini.
  public:
    Radnik(string ime)                       // Inicijalizacija.
      : ime{ime}, mas{nullptr} {}
    Radnik(const Radnik&) =delete;           // Ne sme da se kopira.
    void operator=(const Radnik&) =delete;   // Ne sme da se dodeljuje.
    string dohv_ime() const { return ime; }  // Dohvatanje imena.
    int dohv_id() const { return id; }       // Dohvatanje identifikatora
    Radnik& operator+=(Masina* m)            // Pridruživanje mašine.
      { mas = m; br = 0; return *this; }
    int broj() const {                       // Broj napravljenih proizvoda.
      if (!mas) throw G_nema_masinu(ime, id);
      return br;
    }
    Proizvod* napravi() {                    // Napravi proizvod.
      if (!mas) throw G_nema_masinu(ime, id);
      br++; return mas->napravi();
    }
    friend ostream& operator<<(ostream& it, const Radnik& r) { // Pisanje.
      it << r.ime << '/' << r.id;
      if (r.mas) it << '(' << r.mas->vrsta() << ',' << r.br << ')';
      return it;
    }
  }; // class Radnik
} // namespace Fabrika

#endif
