// red4.h - Klasa redova tačaka pomoću klase deque<>.

#ifndef _red4_h_
#define _red4_h_

#include "tacka4.h"
#include "greska.h"
#include <deque>
#include <iostream>
using std::deque, std::ostream;

class Red4 {
  deque<Tacka> niz;                          // Sadržaj reda.
public:
  void stavi(const Tacka& t)                 // Stavljanje na kraj.
    { niz.push_back(t); }
  Tacka uzmi() {                             // Uzimanje sa početka.
    if (prazan()) throw Usluge::Greska("Red je prazan!");
    Tacka t = niz.front();
    niz.pop_front();
    return t;
  }
  size_t vel() const { return niz.size(); }  // Broj elemenata u redu.
  bool prazan() const { return vel() == 0; } // Da li je red prazan?
  void prazni() { niz.clear(); }             // Pražnjenje reda.
  friend ostream& operator<<(ostream& it, const Red4& r); // Pisanje reda.
};

inline ostream& operator<<(ostream& it, const Red4& r) {  // Pisanje reda.
  for (size_t i=0; i<r.vel();it <<r.niz[i++]<<' ');
  return it;
}

#endif
