// red_tela.cpp - Metode i funkcije uz klasu redova tela.

#include "red_tela.h"

Red_tela::Red_tela(int kap)                  // Konstruktor praznog reda.
  : tela{new Telo*[kap]}, kap{kap},
    duz{0}, prvo{0}, posl{0}
  { for (int i=0; i<kap; tela[i++]=0); }

void Red_tela::kopiraj(const Red_tela& rt) { // Kopiranje u red.
  tela = new Telo*[rt.kap]; kap = rt.kap;
  duz = rt.duz; prvo = rt.prvo; posl = rt.posl;
  for (int i=0; i<kap; i++)
    tela[i] = rt.tela[i] ? rt.tela[i]->kopija() : nullptr;
}

void Red_tela::brisi() {                     // Oslobađanje memorije.
  if (!tela) return;
  for (int i=0; i<kap; delete tela[i++]);
  delete [] tela;
}

ostream& operator<<(ostream& it, // Pisanje.
                    const Red_tela& r) {
  it << "red[";
  for (int i=0; i<r.duz; i++) {
    if (i) it << ',';
    it << *r.tela[(r.prvo+i)%r.kap];
  }
  return it << ']';
}
