// sef.h – Klasa šefova.

#ifndef _sef_h_
#define _sef_h_

#include "radnik2.h"
#include "firma_gr.h"

namespace Trgovina {
  class Sef: public Radnik {
    Radnik** podredjeni;        // Niz podređenih radnika.
    int max_pot, br_pot;        // Najveći i trenutni broj podređenih.
  public:
    Sef(string ime, double procenat, int k=3) // Inicijalizacija.
      : Radnik(ime, procenat),
        podredjeni{new Radnik*[k]}, max_pot{k},
        br_pot{0} {}
    ~Sef() { delete [] podredjeni; }          // Destruktor.
    Sef& dodeli(Radnik* r) {                  // Dodeljivanje podređenog.
      if (br_pot == max_pot) throw G_previse();
      podredjeni[br_pot++] = r;
      return *this;
    }
    double prihod() const override {          // Ostvareni prihod.
      double p = 0;
      for (int i=0; i<br_pot; p+=podredjeni[i++]->prihod());
      return p;
    }
  }; // class Sef
} // namespace Trgovina

#endif
