// skola.h - Klasa škola.

#ifndef _skola_h_
#define _skola_h_

#include "lista7.h"
#include "djak.h"
#include <string>
using std::string;

class Skola {
  string ime;                              // Ime škole.
  Lista<Djak*> djaci;                      // Lista đaka.
 
public:
  Skola(string ime): ime{ime} {}             // Konstruktor.
  Skola(const Skola&) =delete;               // Ne sme da se kopira.
  Skola& operator=(const Skola&) =delete;    // Ne sme da se dodeljuje.
  Skola& operator+=(Djak& djak)              // Dodavanje đaka.
    { djaci.dodaj(&djak); return *this; }
  const Djak* najbolji() const;              // Đak s najvišim prosekom.
};

inline const Djak* Skola::najbolji() const { // Đak s najvišim prosekom.
  Djak* naj = nullptr; double max = 0;
  for (djaci.naPrvi(); djaci.imaTek(); djaci.naSled()) {
    Djak* tek = djaci.dohvTek();
    double m = tek->srOce();
    if (m > max) { max = m; naj = tek; }
  }
  return naj;
}

#endif
