// skup1.h - Definicija klase uređenih skupova.

class Skup {
  int vel; double* niz;                   // Veličina i elementi skupa.
  void kopiraj(const Skup&);              // Kopiranje u skup.
  void premesti(Skup& s)                  // Premeštanje u skup.
    { vel = s.vel; niz = s.niz; s.niz = nullptr; }
  void brisi()                            // Oslobađanje memorije.
    { delete [] niz; niz = nullptr; vel = 0; }
public:
  Skup() { niz = nullptr; vel = 0; }      // Stvaranje praznog skupa.
  Skup(double a) {                        // Konverzija broja u skup.
    niz = new double [vel = 1];
    niz[0] = a;
  }
  Skup(const Skup& s) { kopiraj(s); }     // Inicijalizacija kopiranjem.
  Skup(Skup&& s) { premesti(s); }         // Inicijalizacija premeštanjem.
  ~Skup() { brisi(); }                    // Uništavanje skupa.
  void unija  (const Skup&, const Skup&); // Unija dva skupa.
  void presek (const Skup&, const Skup&); // Presek dva skupa.
  void razlika(const Skup&, const Skup&); // Razlika dva skupa.
  void pisi () const;                     // Pisanje skupa.
  void citaj();                           // Čitanje skupa.
  int velicina() const { return vel; }    // Veličina skupa.
};
