// skup_troug.h - Klasa skupova trouglova u ravni.

#include "trougao3.h"
#include <iostream>
using std::ostream;

class Skup_troug {
  struct Elem {                                // Element liste.
    Trougao t; Elem* sled;
    Elem(const Trougao& t): t{t}, sled{nullptr} {}
  };
  Elem *prvi, *posl;                           // Početak i kraj liste.
  void kopiraj(const Skup_troug& st);          // Kopiranje u objekat.
  void premesti(Skup_troug st) {               // Premeštanje u objekat.
    prvi = st.prvi; posl = st.posl;
    st.prvi = nullptr;
  }
  void brisi();                                // Oslobađanje memorije.

public:
  Skup_troug(): prvi{nullptr}, posl{nullptr} {}// Stvaranje praznog skupa.
  Skup_troug(const Skup_troug& st)             // Kopirajući konstruktor.
    { kopiraj(st); }
  Skup_troug(Skup_troug&& st)                  // Premeštajući konstruktor.
    { premesti(st); }
  ~Skup_troug() { brisi(); }                   // Destruktor.
  Skup_troug& operator=(const Skup_troug& st) {// Kopirajuća dodela
    if (this != &st){ brisi(); kopiraj(st); }  //   vrednosti.
    return *this;
  }
  Skup_troug& operator=(Skup_troug&& st) {     // Premeštajuća dodela
    if (this != &st){ brisi(); premesti(st); } //   vrednosti.
    return *this;
  }
  bool ima(const Trougao& t) const;          // Da li postoji u skupu?
  Skup_troug& operator+=(const Trougao& t);  // Dodavanje trougla.
  double ukP() const;                        // Ukupna površina trouglova.
  friend ostream& operator<<(ostream& it, const Skup_troug& s); // Pisanje.
};
