// tekst3.h - Klasa tekstova.

#ifndef _tekst3_h_
#define _tekst3_h_

#include "objekat.h"
#include <cstring>
#include <utility>
using std::strcmp, std::strlen, std::strcpy, std::move;

class Tekst: public Obj {
  char* tks;                                   // Sadržaj objekta.
  bool jednako(const Obj& obj) const           // Da li su jednaki?
    { return strcmp(tks, ((Tekst&)obj).tks) == 0; }
 
  void pisi (ostream& it) const                // Pisanje objekta.
    { it << '[' << (tks ? tks : "") << ']'; }
  void citaj(istream& ut);                     // Čitanje objekta.
  void kopiraj(const char* niz);               // Kopiranje u objekat.
  void premesti(Tekst& t) {                    // Premeštanje u objekat.
    tks = t.tks; t.tks = nullptr;
  }
public:
  Tekst(const char* niz="") { kopiraj(niz); }  // Inicijalizacija niskom.
  Tekst(const Tekst& t): Obj{t}                // Inicijalizacija tekstom
    { kopiraj(t.tks); }                        //   kopiranjem.
  Tekst(Tekst&& t): Obj{move(t)}               // Inicijalizacija tekstom
    { premesti(t); }                           //   premeštanjem.
  ~Tekst() { delete [] tks; }                  // Uništavanje objekta.
  Tekst& operator=(const Tekst& t) {       // Dodela vrednosti kopiranjem.
    if (this != &t) { delete [] tks; Obj::operator=(t); kopiraj(t.tks); }
    return *this;
  }
  Tekst& operator=(Tekst&& t) {           // Dodela vrednosti premeštanjem.
    if (this != &t)
      { delete[] tks; Obj::operator=(move(t)); premesti(t); }
    return *this;
  }
  string klasa() const override { return "Tekst"; }           // Ime klase.
  Tekst* kopija() const& override          // Kopija objekta kopiranjem.
    { return new Tekst(*this); }
  Tekst* kopija() && override              // Kopija objekta premeštanjem.
    { return new Tekst(move(*this)); }
};

#endif
