// tekst4.h - Klasa tekstova.

#ifndef _tekst4_h_
#define _tekst4_h_

#include "figura4.h"
#include "vektor4.h"
#include "font.h"
#include <string>
#include <iostream>
#include <utility>
using std::string, std::ostream, std::move;

class Tekst: public Figura {
  string tks;                                        // Sadržani tekst.
  double vis;                                        // Visina znakova.
  Font fnt;                                          // Korišćeni font.
  Vektor poz;                                        // Položaj u ravni.
  void pisi(ostream& it) const override              // Pisanje.
    { it << tks << '[' << poz << ',' << vis << ',' << sirina() << ']'; }
public:
  Tekst(const char* tks, double h, const Font& f,    // Inicijalizacija.
        const Vektor& p): tks{tks}, vis{h}, fnt{f}, poz{p} {}
  double visina() const { return vis; }              // Visina znakova. 
  double sirina() const;                             // Širina teksta.
  Tekst& operator+=(const Vektor& v) override        // Pomeranje teksta.
    { poz += v; return *this; }
  Tekst* kopija() const& override             // Kopija teksta kopiranjem.
    { return new Tekst(*this); }
  Tekst* kopija() && override                 // Kopija teksta premeštanjem.
    { return new Tekst(move(*this)); }
};

inline double Tekst::sirina() const {                // Širina teksta.
  double s = 0;
  for (unsigned i=0; i<tks.length(); s += fnt[tks[i++]].sirina(vis));
  return s;
}

#endif
