// ugao.h - Definicija klase uglova.

#include <iostream>
using std::cin, std::cout;

const double FAKTOR = 3.14159265358979323 / 180;

class Ugao {
  double ugao;                                    // Ugao u radijanima.
public:                                           // Konstruktori:
  Ugao(double u=0)                                //  - podrazumevani i
    { ugao = u; }                                 //    konvertujući,
  Ugao(int stp, int min=0, int sek=0)             //  - na osnovu stepeni.
    { ugao = ((sek/60.+min)/60+stp) * FAKTOR; }
  double rad() const { return ugao; }             // Radijani.
  int stp() const                                 // Stepeni.
    { return int(ugao / FAKTOR); }
  int min() const                                 // Minuti.
    { return int(ugao / FAKTOR * 60) % 60; }
  int sek() const                                 // Sekunde.
    { return int(ugao / FAKTOR * 3600) % 60; }
  void razlozi(int& st, int& mi, int& se) const { // Sva tri dela odjednom.
    st = stp(); mi = min(); se = sek();
  }
  Ugao& dodaj(Ugao u)                             // Dodavanje ugla.
    { ugao += u.ugao; return *this; }
  Ugao& pomnozi(double a)                         // Množenje realnim brojem
    { ugao *= a; return *this; }
  void citaj() { cin >> ugao; }                   // Čitanje u radijanima.
  void citajStep() {                              // Čitanje u stepenima.
    int stp, min, sek; cin >> stp >> min >> sek;
    *this = Ugao(stp, min, sek);
  }
  void pisi() const { cout << ugao; }             // Pisanje u radijanima.
  void pisiStep() const {                         // Pisanje u stepenima.
    cout << '(' << stp() << ':' << min() << ':' << sek() << ')';
  }
};
