// valjak1.h - Klasa valjaka.

#include <iostream>
using std::ostream;

const double PI = 3.1415926535897932;

class Valjak {
  double r, h;                                     // Poluprečnik i visina.
public:
  explicit Valjak(double r=1, double h=1)         // Inicijalizacija.
    : r{r}, h{h} {}
  double R() const { return r; }                           // Poluprečnik.
  double H() const { return h; }                           // Visina.
  double V() const { return r * r * PI * h; }              // Zapremina.
  friend ostream& operator<<(ostream& it, const Valjak& v) // Pisanje.
    { return it << '[' << v.r << ',' << v.h << ']'; }
};
