// valjak2.h - Klasa valjaka.

#ifndef _valjak2_h_
#define _valjak2_h_

#include "telo1.h"
#include <utility>
using std::move;

class Valjak: public Telo {
  double r, h;                                // Poluprečnik i visina.
public:
  Valjak(double r=1, double h=1):r{r},h{h} {} // Stvaranje valjka.
  char vrsta() const override { return 'V'; } // Oznaka vrste tela.
  double V() const override                   // Zapremina valjka.
    { return r*r * 3.14159 * h; }
  Valjak* kopija() const& override            // Kopija valjka kopiranjem.
    { return new Valjak(*this); }
  Valjak* kopija() && override                // Kopija valjka premeštanjem.
    { return new Valjak(move(*this)); }
private:
  void pisi(ostream& it) const override       // Pisanje valjka.
    { it << "V(" << r << ',' << h << ')'; }
};

#endif
