// voz1.h - Klasa vozova.

#ifndef _voz1_h_
#define _voz1_h_

#include "vozilo2.h"
#include "lokomot1.h"
#include "p_vagon.h"
#include <iostream>
#include <string>
using std::ostream, std::endl, std::string;

namespace Vozovi {
  class G_ima_lok {};   // KLASA GREŠAKA: Već postoji lokomotiva.
  inline ostream& operator<<(ostream& it, const G_ima_lok)
    { return it << "*** Vec ima lokomotive! ***"; }

  class G_nema_lok {};  // KLASA GREŠAKA: Još nema lokomotive.
  inline ostream& operator<<(ostream& it, const G_nema_lok)
    { return it << "*** Jos nema lokomotive! ***"; }

  class G_tezak_voz {}; // KLASA GREŠAKA: Lokomotiva je preopterećena.
  inline ostream& operator<<(ostream& it, const G_tezak_voz)
    { return it << "*** Pretezak voz! ***"; }

  class Voz {                             // KLASA VOZOVA:
    string ime;                           // Ime voza.
    struct Elem {                         // Element liste vozila.
      Vozilo* vozilo; Elem* sled;
      Elem(Vozilo* v): vozilo{v}, sled{nullptr} {}
      ~Elem(){ delete vozilo; }
    };
    Elem *prvi, *posl;                    // Prvi i poslednji element liste.
    void kopiraj(const Voz& v);           // Kopiranje u objekat.
    void premesti(Voz& v) {               // Premeštanje u objekat.
      ime = v.ime; prvi = v.prvi; posl = v.posl;
      v.prvi = v.posl = nullptr;
    }
    void brisi();                         // Oslobađanje memorije.
  public:
    Voz(string ime)                      // Inicijalizacija.
      : ime{ime}, prvi{nullptr}, posl{nullptr} {}
    Voz(const Voz& v) { kopiraj(v); }        // Kopirajući konstruktor.
    Voz(Voz&& v) { premesti(v); }            // Premeštajući konstruktor.
    ~Voz() { brisi(); }                      // Destruktor.
    Voz& operator=(const Voz& v) {           // Kopirajuća dodela vrednosti.
      if (this != &v) { brisi(); kopiraj(v); }
      return *this;
    }
    Voz& operator=(Voz&& v) {                // Premeštajuća dodela vredn.
      if (this != &v) { brisi(); premesti(v); }
      return *this;
    }
    Voz& operator+=(const Lokomot& lok);     // Dodavanje lokomotive.
    Voz& operator+=(Lokomot&& lok);
    Voz& operator+=(const P_vagon& pvag);    // Dodavanje putničkog vagona.
    Voz& operator+=(P_vagon&& pvag);
    float uk_tez_voza() const;               // Ukupna težina voza.
    friend ostream& operator<<(ostream& it,const Voz& v); // Pisanje voza.
  }; // class Voz
} // namespace Vozovi
#endif
